const fs = require('fs');
const path = require('path');
const DEFAULT_POWER = '0777';
const DEFAULT_ENCODE = 'utf8';

module.exports.rd = {
  file(fp){
    return fs.readFileSync(fp,DEFAULT_ENCODE);
  }
};

module.exports.wt = {
  file(fp,data){
    const writeable = fs.createWriteStream(fp,{flag: 'wx',mode: DEFAULT_POWER});

    writeable.write(data);
    writeable.on('finish',()=>{
      finish && finish();
    });
  }
};

module.exports.is = {
  directory(p){
    try{
      const stats = fs.statSync(p);
      return stats.isDirectory();
    }catch(e){
      return false;
    }
  },
  file(p){
    try{
      const stats = fs.statSync(p);
      return stats.isFile();
    }catch(e){
      return false;
    }
  },
};

module.exports.cpy = {
  file(fp,to,finish){
    fs.readFile(fp,DEFAULT_ENCODE,(e,data)=>{
      if(e){
        throw e;
      }
      const writeable = fs.createWriteStream(to,{flag: 'wx',mode: DEFAULT_POWER});

      writeable.write(data);
      writeable.on('finish',()=>{
        finish && finish();
      });
    });
  },
};

module.exports.mk = {
  directory(p,cb){
    fs.mkdir(p,e=>{
      if(e){
        throw e;
      }
      cb && cb();
    });
  },
  deepDirectory(dirs,cb){
    const _dirs = Object.assign({},dirs);

    for(const dn in _dirs){
      if(!is.directory(_dirs[dn])){
        this.directory(_dirs[dn],cb);
      }
    }
  },
  file(p,c = '',cb){
    fs.writeFile(p,c,{
      flag:'wx',
      mode: DEFAULT_POWER,
     },(e)=>{
      if(e){
        throw e;
      }
      cb && cb();
    });
  },
};
