const {ifEmpty, ifNoEmpty, deepOne} = require('./process');
const {is, mk, cpy, rd, wt} = require('./file');

function Struct(){
  this.params = {
    output: process.cwd(),
    injectOrigin: process.cwd(),
    files: [],
    dirs: {},
    fetchTimes: 0,
  };
};

Struct.prototype.directory = function(map,parent = ''){
  for(const dn in map){
    const src = `${parent === ''?'':`${parent}/`}${dn}`;

    if(map[dn] instanceof Array){
      ifEmpty(map[dn].length === 0, src, map, dn);
      ifNoEmpty(map[dn].length > 0, src, map, dn);
    }else if(typeof map[dn] === 'object'){
      this.directory(map[dn], src);
    }

    map[dn].src = src;
  }

  this.params.dirs = map;
};

Struct.prototype.file = function(cb){
  cb && cb({
    build: src => {
      this.params.files.push(src);
    },
    injectOrigin: path => {
      this.params.injectOrigin = path;
    },
  },this.params.dirs);
};

Struct.prototype.alias = function(path=process.cwd()){
  const alias = {};
  const ps = (dirs,parent='')=>{
    if(typeof dirs === 'object'){
      for(const n in dirs){
        if(n !== 'src'){
          ps(dirs[n],`${parent === ''? parent:`${parent}/`}${n}`);
        }
      }
    }
    if(parent){
      alias[parent] = `${path === ''? path:`${path}/`}${parent === ''? parent:`${parent}`}`;
    }
  };

  ps(this.params.dirs);
  return alias;
};

Struct.prototype.output = function(opt,cons){
   const dirs =  deepOne(this.params.dirs);
   const files = this.params.files;
   const injectPath = this.params.injectOrigin;
   const fetchTimes = this.params.fetchTimes;
   const options = {
     origin: this.params.output,
     fetch: true
   };

   if(typeof opt === 'string'){
     options.origin = opt;
   }else if(typeof opt === 'object'){
     for(const cn in options){
       if(opt.hasOwnProperty(cn)){
         options[cn] = opt[cn];
       }
     }
   }

   if(!is.directory(options.origin)){
     mk.directory(options.origin);
   }

   for(let j=0;j<dirs.length;j++){
     const dpath = `${options.origin}/${dirs[j]}`;

     if(!is.directory(dpath)){
       mk.directory(dpath);
     }
   }
   for(let i=0;i<files.length;i++){
     const fpath = `${options.origin}/${files[i]}`;
     const opath = `${injectPath}/${files[i]}`;

     if(is.file(opath) && options.fetch){
       let data = rd.file(opath);

       if(/^\s{0,}$/g.test(data) || !is.file(fpath)){
         for(const ky in cons){
           const reg = new RegExp(`\\$${ky.toUpperCase()}\\$`,'g');
           let consVal = cons[ky];

           if(typeof cons[ky] === 'object'){
             consVal = JSON.stringify(cons[ky],null,'\t');
             consVal = consVal.replace(/"/g,'\'');
           }

           data = data.replace(reg,consVal);
         }
         wt.file(fpath,data);
       }

       options.fetchTimes++;
     }else if(!is.file(fpath)){
       mk.file(fpath);
     }
   }
};

module.exports = Struct;
